﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.LinkLabel;

namespace BCM_IP_Compare
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void do_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            if (files != null && files.Length != 0)
            {
                textBoxFile1.Text = files[0];
                if (files.Length > 1)
                    textBoxFile2.Text = files[1];
            }

        }

        private void do_DragDrop2(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            if (files != null && files.Length != 0)
            {
                textBoxFile2.Text = files[0];
                if (files.Length > 1)
                    textBoxFile1.Text = files[1];
            }
        }

        private void panel1_DragEnter(object sender, DragEventArgs e)
        {

        }

        private void panel1_DragOver(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Copy;
            else
                e.Effect = DragDropEffects.None;
        }

        private void buttonCompare_Click(object sender, EventArgs e)
{
            if (File.Exists(textBoxFile1.Text) && File.Exists(textBoxFile2.Text))
            {
                string[] file1, file2;
                buttonCompare.Enabled = true;
                using (var f = new StreamReader(textBoxFile1.Text))
                {
                    file1 = f.ReadToEnd().Split('\n');
                }
                resultBox.Text += $"{textBoxFile1.Text} contains {file1.Count()} lines:\r\n";
                using (var f = new StreamReader(textBoxFile2.Text))
                {
                    file2 = f.ReadToEnd().Split('\n');
                }
                resultBox.Text += $"{textBoxFile2.Text} contains {file2.Count()} lines:\r\n";

                if (file1.Count() < file2.Count()) 
                    parse(file2, file1);
                else
                    parse(file1, file2);
            }
            
}
        enum States
        {
            header,idle,indifference
        }

        private void parse(string[] largerFile, string[] smallerFile)
        {
            States state = States.header;
            int sublin = 0;
            for (int lin = 0; lin < largerFile.Count()-1; lin++)
            {
                string line1 = largerFile[lin];
                string line2 = smallerFile[sublin];
                switch (state)
                {
                    case States.header:
                        resultBox.Text += line1 + "\r\n";
                        if (line1.Contains("Sequence Number"))
                        {
                            state = States.idle;
                        }
                        sublin++;
                        break;
                    case States.idle:
                        if (line1 == line2)
                        {
                            //resultBox.Text += $"{state.ToString()}={lin}:\r\n\tFILE 1:{line1}\r\n\tFILE 2:{line2}\r\n";
                            sublin++;
                        }
                        else
                        {
                            //resultBox.Text += $"{state.ToString()}={lin}:\r\n\tFILE 1:{line1}\r\n\tFILE 2:{line2}\r\n";
                            resultBox.Text += $"{line1}\r\n";
                            state = States.indifference;
                        }
                        break;
                    case States.indifference:
                        if (line1[0] == '\t')
                            //resultBox.Text += $"{state.ToString()}={lin}:\r\n\tFILE 1:{line1}\r\n";
                            resultBox.Text += $"{line1}\r\n";
                        else
                        {
                            //resultBox.Text += $"{state.ToString()}={lin}:\r\n\tFILE 1:{line1}\r\n\tFILE 2:{line2}\r\n";
                            sublin++;
                            state = States.idle;
                        }
                        break;
                    default:
                        break;
                }
                Application.DoEvents();
            }
        }
    }
}
